Description

When trying to provision a new host for vmware, I got a

2015-03-23 17:19:09 [W] Create DHCP Settings for xxx task failed with the following error: Invalid MAC

/usr/share/foreman/lib/net/validations.rb:40:in `validate_mac'

It seems to fail to get a mac address from vsphere. After the error occurs the VM Tab is also unusable saying that the host might be

deleted or there was problem communication with vsphere.

See attached stacktrace.txt

Related issues:

Related to Foreman - Bug #9966: Add debug logging when host interfaces cannot... Closed 03/31/2015

Related to Foreman - Bug #9970: Creating hosts with NICs on vmWare fails with... Resolved 03/31/2015

History

#1 - 03/23/2015 12:52 PM - Dominic Cleal

- Category set to Compute resources - VMware

Do you have any more of the log file?  It would be useful to see up to the POST that created the host.

#2 - 03/24/2015 05:35 AM - Konrad Lother

Dominic Cleal wrote:

Do you have any more of the log file?  It would be useful to see up to the POST that created the host.

 Sadly not as we've already rolled back to 1.7.3. :-(

#3 - 03/27/2015 11:36 AM - Dominic Cleal

- File 9871_info.txt added

- File 9871_debug.txt added

- Status changed from New to Need more information

It appears that no MAC address is being retrieved from the VM created on the VMware compute resource, so no MAC is stored and we later get a

validation error.

Attaching two log files from today's IRC session.  One at info level, the other at debug in the hope we'd see the NIC to host interface matching code in

app/models/concerns/orchestration/compute.rb in action.  No debug logs for this were seen.

If anybody can attempt again with the following debug added, it would be appreciated: 

https://github.com/theforeman/foreman/compare/develop...tstrachota:nic_debug

Also enable debug logging as per http://projects.theforeman.org/projects/foreman/wiki/Troubleshooting#How-do-I-enable-debugging
#4 - 03/27/2015 03:07 PM - Alexander Litvinenko

- File wyQnQQ88.txt added

Here is log output with new debugging options.

#5 - 03/30/2015 08:18 AM - Dominic Cleal

Thanks Alexander, that contained valuable information.

Foreman 1.8 tries to match the NICs specified during creation to the networks that it sees on the VM created.  The network requested is

"network"=>"vlan60-Internal", but the one created was network="dvportgroup-236" ("DVSwitch: f4 1e 2d 50 ac 49 e8 45-59 22 ba 45 20 23 46 66"). 

Do you know if those are related in any way, or maybe we have an issue with it creating VMs with the wrong network?

#6 - 03/31/2015 03:47 AM - Alexander Litvinenko

I was run in issue when VM network is wrong (missed on host but present on cluster) - VM creation process is aborted with error and vm is not

created.

In this case VM is created, but deleted very shortly (couple of seconds).

#7 - 03/31/2015 06:06 AM - Dominic Cleal

- Related to Bug #9966: Add debug logging when host interfaces cannot be matched to VM interfaces added

#8 - 03/31/2015 06:08 AM - Dominic Cleal

- Status changed from Need more information to Feedback

- translation missing: en.field_release deleted (28)

Thanks for confirming Alexander, that sounds plausible.  I filed #9966 to get the debug logging added as standard.

I'll set this to feedback now, so if anybody else hits it, please check the host vs cluster configuration described above and if there's still an issue, we'll

revisit.

#9 - 03/31/2015 08:19 AM - Tomáš Strachota

- Related to Bug #9970: Creating hosts with NICs on vmWare fails with "Unknown Network ID:" added

#10 - 04/15/2015 10:24 PM - Francois Herbert

I'm running into this issue. It seems to be caused by Fog returning back the portgroup as the network value instead of the network name.

Data returned from Fog:

- !ruby/object:Fog::Compute::Vsphere::Interface

attributes:

:server_id: 501aa99a-1726-dc69-3e6e-185c069592a3

:name: Network adapter 1

:network: dvportgroup-87

:summary: ! 'DVSwitch: be 0c 1a 50 3a 62 17 09-ba a4 0a 88 ad a6 96 a0'

:type: &92509260 !ruby/class 'RbVmomi::VIM::VirtualVmxnet3'

:mac: 77:88:99:00:11:22

:status: untried

:key: 4000

Data from foreman:

- !ruby/object:Nic::Managed

attributes:

id:

mac:

ip:

type: Nic::Managed

name: example.domain.com

host_id:

subnet_id: 1

domain_id: 1

attrs: {}

created_at:

updated_at:

provider:

username:

password:

virtual: false

link: true
identifier: ''

tag: ''

attached_to: ''

managed: true

mode: balance-rr

attached_devices: ''

bond_options: ''

primary: true

provision: true

compute_attributes: !ruby/hash:ActiveSupport::HashWithIndifferentAccess

type: VirtualVmxnet3

network: DPT_MAIN_PROD_200

And since the code in app/models/concerns/fog_extensions/vsphere/server.rb matches on network name (for some reason) the match fails.

It's not making a lot of sense to me matching on network name when more than one nic can be on the same network, so I can suggest the following

to fix this:

1. Add a hidden field (name) to app/views/compute_resources_vms/form/vmware/_network.html.erb which on submit gets populated with the interface

name (from the host_interfaces_attributes_0_name field). This results in fog creating the nic with the label = name (code already present in fog -

create_vm.rb), and when fog is then queried it returns the name of the adapter as whatever this label was set to (defaults to Network Adapter n)

2. Match nic's on name instead of network (what happens when we have 2 nics on the same network??) - by modifying the select_nic function in

app/models/concerns/fog_extensions/vsphere/server.rb

Number 2 I can do fairly easily, but I'm struggling with number 1 :-(

#11 - 04/15/2015 10:57 PM - Francois Herbert

I've just tested creating a new vm with a named nic but although the label is passed to vsphere, the returned name is still 'Network adapter 1'. So that

idea isn't going to work.

#13 - 04/20/2015 06:33 AM - Dominic Cleal

Francois' new issue #10186 will continue to track this issue around distributed port groups.

#14 - 05/17/2017 10:28 AM - Anonymous

- Status changed from Feedback to Resolved

it seems the original issue got solved and other problems are tracked in other issues
